package i382;

import java.io.*;
import java.net.*;
import java.sql.*;

/**
 *
 * <p>Title: Rezervan kancel</p>
 * <p>Description: Rezervan kancel po internetu</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jan Doleel
 * @version 1.0
 * Each Clerk is created by server to deal with one client
 * @see ServerSide
 */

public class Clerk extends Thread {
  static int ctr=0;
  int id=0;
  private Socket client;
  private ObjectInputStream in;
  private ObjectOutputStream out;
  private ResultSet result;
  private ResultSetMetaData rsmd;

  /**
   * Initialize the streams and start the thread
   * @param client_socket Number of socket, incoming call
   */

  public Clerk(Socket client_socket) {
    id=++ctr;
    client = client_socket;
    try {
      out = new ObjectOutputStream( client.getOutputStream());
      in =  new ObjectInputStream(  client.getInputStream());
      //System.out.println("Clerk streams  "+out+"  "+in);
    }
    catch (IOException e) {
      System.err.println("Error in creating streams");
      try {
        client.close();
      }
      catch (IOException e2) {
        System.err.println("err. socket streams: " + e);
      }
      return;
    }
    this.start();
  }

  /**
   * Provides all services - very complex
   */

  public void run() {

    System.out.println(">>>  Clerk  "+id+"  started with "+client);
    String line, res;
    try {
      out.writeObject("DB service ready\n");
      out.reset();
      // Connecting to database
      out.writeObject(DB.connectDriver("com.mysql.jdbc.Driver"));
      out.writeObject(DB.connectDB("jdbc:mysql://localhost:3306/Vstupenky"));
      // Retrieving list of available action areas
      result = DB.select("SELECT * FROM oblast;");
      String s="";
      while(result.next()) {
        s += result.getString("jmeno") + "@";
      }
      // Sending actions list back to user
      out.writeObject(s);
      out.reset();

      for(;;) {
        line =(String) in.readObject();   // read in a line
        System.out.println(">>>  Clerk  "+id+"  read="+line);
        if(line.equals("Closing")) break;
        // Trying to create new record
        if(line.startsWith("Novy")) {
          String[] pole = line.split("@",8);
          // Was this name already used for another action?
          result = DB.select("SELECT * FROM akce WHERE jmeno = '"+pole[1]+"';");
          if(result.first()) {
            out.writeObject("CHYBA: Toto jmeno jiz bylo pouzito!");
          }
          // Trying to create new area of actions?
          result = DB.select("SELECT * FROM oblast WHERE jmeno = '"+pole[2]+"';");
          if(!result.first()) {
            // So create it
            DB.update("INSERT INTO oblast (jmeno) VALUES('" + pole[2] + "')");
          }
          // Insert new action
          DB.update("INSERT INTO akce (jmeno,oblast,kde,kdy,vyzvednuti,kontakt,ceny)"+
                    "VALUES ('" + pole[1] + "','" + pole[2] + "','" + pole[3] +
                    "','" + pole[4] + "','" + pole[5] + "','" + pole[6] +
                    "','" + pole[7] + "');");
          s = "OK";
          // Send back the result
          out.writeObject(s);
        }
        // Searching for available actions
        if(line.startsWith("Hledej")) {
          String[] pole = line.split("@",5);
          String kde = "";
          String oblast = "";
          if(!pole[1].equals("vechny kraje")) {
            kde = " AND kde = '" + pole[1] +"'";
          }
          if(!pole[4].equals("vechny oblasti")) {
            oblast = " AND oblast = '" + pole[4] + "'";
          }
          // Use formated string for query
          result = DB.select("SELECT jmeno FROM akce WHERE kdy BETWEEN '" +
                             pole[2] + "' AND '" + pole[3] +"'" + kde + oblast +
                             ";");
          s="";
          // Retrieve names of actions
          while(result.next()) {
            s += result.getString("jmeno") + ";";
          }
          // and send them back
          out.writeObject(s);
        }
        // Detail informations about action
        if(line.startsWith("Dej")) {
          String[] pole = line.split("@",2);
          // Get informations from action name
          result = DB.select("SELECT * FROM akce WHERE jmeno ='"+pole[1]+"';");
          result.first();
          s= result.getString("jmeno") + "@" + result.getString("oblast") + "@" +
              result.getString("kde") + "@" + result.getString("kdy") + "@" +
              result.getString("vyzvednuti") + "@" + result.getString("kontakt") +
              "@" + result.getString("ceny");
          // send them back
          out.writeObject(s);
        }
        // Trying to make a reservation for given action
        if(line.startsWith("Rezerv")) {
          String[] pole = line.split("%",5);
          // Insert the data about reservation into database
          DB.update("INSERT INTO klient (jmeno,klient,adresa,cena) VALUES" + "('" +
                    pole[1] + "','" + pole[2] + "','" + pole[3] + "','" +
                    pole[4] +"');");
          // Substract number of available tickets
          String[] ceny = pole[4].split("@");
          result = DB.select("SELECT * FROM akce WHERE jmeno = '" + pole[1] +"';");
          result.first();
          s = result.getString("ceny");
          String[] cenik = s.split("\n");
          String noveceny = "";
          for(int i=0; i< cenik.length; i++) {
            String[] dve = cenik[i].split(";");
            if(dve[1].equals("x")) {
              noveceny += cenik[i] + "\n";
            }
            else {
              noveceny += dve[0] + ";" + (Integer.parseInt(dve[1]) -
                                          Integer.parseInt(ceny[i])) + "\n";
            }
          }
          // put back updated informations
          DB.update("UPDATE akce SET ceny = '" + noveceny + "' WHERE jmeno='" +
                    pole[1] + "';");
          s = "Rezervace probhla";
          out.writeObject(s);
        }
        // Retrieve complete informations about action and reservations
        if(line.startsWith("Seznam")) {
          String jmeno = (line.split("@",2))[1];
          // Get action informations
          result = DB.select("SELECT * FROM akce WHERE jmeno = '" + jmeno + "';");
          if(!result.first()) {
            s = "Zznam nenalezen";
            out.writeObject(s);
          }
          else {
            s = result.getString("oblast") + "@" + result.getString("kde") + "@" +
                result.getString("kdy") + "@" + result.getString("vyzvednuti") +
                "@" + result.getString("kontakt") + "@" + result.getString("ceny") + "@";
            // Get informations about reservations
            result = DB.select("SELECT * FROM klient WHERE jmeno = '" + jmeno + "';");
            while(result.next()) {
              s += result.getString("klient") + "%" + result.getString("adresa") +
                  "%" + result.getString("cena") + "\n";
            }
            out.writeObject(s);
          }
        }

        System.out.println(">>>  Clerk  "+id+"  res=" + s);
        out.reset();
      }
    }
    catch (Exception e) {
      System.err.println("Unspecified error or applet closing");
    }
    finally {
      System.out.println("Closing connection with client n."+id);
      try {
        client.close();
      }
      catch (IOException e2) {
        System.err.println("Unspecified error in closing connection");
      }
    }
  }
}