package i382;

import java.sql.*;
import java.util.*;

/**
 * <p>Title: Rezervan kancel</p>
 * <p>Description: Rezervan kancel po internetu</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jan Dolezel
 * @version 1.0
 * Class for communicating of server with database
 * @see ServerSide
 */

public class DB {
  static Connection con;
  static Statement stmt;
  static ResultSet result;

  /**
   * Closing connection with database
   * @throws SQLException On closing error throws exception
   */

  public static void close() throws SQLException {
    con.close();
  }

  /**
   * Executes SELECT statements
   * @param cmd What to execute
   * @return Returns results of query
   */

  public static ResultSet select(String cmd) {
    try {
      result = stmt.executeQuery(cmd);
    }
    // Can't be
    catch (SQLException e) {
      System.err.println("Error in executing query");
      e.printStackTrace();
    }
    return result;
  }

  /**
   * Executing UPDATE and INSERT statements
   * @param cmd What to execute
   */

  public static void update(String cmd) {
    try {
      stmt.executeUpdate(cmd);
    }
    // Can't be
    catch (SQLException e) {
      System.out.println("Error in execute update");
      e.printStackTrace();
    }
  }

  /**
   * Connecting to database
   * @param cmd Database name
   * @return Result of connecting to database
   */

  public static String connectDB(String cmd) {
    String s = "Database=";
    try {
      System.out.println("     Connection through DriverManager to " + cmd);
      con = DriverManager.getConnection(cmd); //<<<<<<<<<
      System.out.println("     Created connection=" + con);
      stmt = con.createStatement(); //<<<<<<<<<
      s += stmt;
    }
    catch (Exception e) {
      s += e.toString();
    }
    return s;
  }

  /**
   * Inicializing database driver
   * @param cmd Name of driver
   * @return Result of loading the driver
   */

  public static String connectDriver(String cmd) {
     String s="     Available drivers:";
     try {
       Class.forName(cmd);  //<<<<<<<<<
       Enumeration k=DriverManager.getDrivers();
       while (k.hasMoreElements()) s=s+"\n  "+k.nextElement();
     }
     catch (Exception e) { s=e.toString(); }
     System.out.println("returns="+s);
     return s;
  }
}